Subject: Re: [core] a question about the Message Format in draft-tschofenig-core-coap-tcp-tls-00

From: "zhengfei (E)" <[email-masked]>
Date: Sat, 21 Nov 2015 03:20:27 +0000

Hi, Bormann

Thank you very much for your quick updating to -01,
I think a clear uniform scheme(L1 only) could greatly improve the compatibility between different implementations.

The simple 4-byte TCP-CoAP packet head whose length is same to UDP-CoAP really looks good,
especially when CoAP stack will implement to be a dual stack, who supports both over UDP and over TCP simultaneously.
I will modify our implementation from L3 to L1 too, following this updated draft.
-------
Finally, sorry that I have used my private email and an empty name previously, my name is Zheng Fei.
Thanks again.☺

------------------ 原始邮件 ------------------
发件人: Carsten Bormann <[email-masked]<mailto:[email-masked]>>
发送时间: 2015年11月20日 01:13
收件人: 774163 <[email-masked]<mailto:[email-masked]>>
抄送: slemay <[email-masked]<mailto:[email-masked]>>, vsolorzanobarboza <[email-masked]<mailto:[email-masked]>>, Hannes.tschofenig <[email-masked]<mailto:[email-masked]>>
主题: Re: a question about the Message Format in draft-tschofenig-core-coap-tcp-tls-00

Hi 774163,

(how do you pronounce your name? :-)

> I have a question about the latest document now.
> About the Message Format, In section 4, I can see that you choose the L1
> scheme, and no other schemes are mentioned, so if I can draw conclusion
> that L1 is the draft standard, and other schemes are No longer within
> the scope of the consideration?

That is the result of the Yokohama meeting and the consensus call we had
after that.

> But in section 3 --> "unless alternative L3 below is chosen"
> It seems that other schemes are still valid? I'm really confused about this.

Oops.

Failing to remove this remnant was my editorial oversight.
Thank you for alerting us.  I just submitted an update, -01, to remove
this confusing passage.

> I think most users are hesitating between L1 and L3. Actually we have
> implement the L3 scheme but I really like L1 scheme.

Indeed, the WG has been hesitating a while as well.
In the end, the simplicity of L1 won over the generality (and slightly
improved efficiency) of L3.

> Because L1 is
> simple, its length is fixed so it easy to implement. And I think 2-byte
> is enough in most cases. If 2-byte is not enough, 4-byte still can be
> not enough in theory. Besides, we has block protocol to deal the extreme
> case. :)

Exactly!
These are pretty much the thought processes that led to this result.

> so if L1 scheme is the only valid scheme?

Yes, that is the outcome of the consensus process.

Thanks again for reaching out and notifying us of this oversight.

Grüße, Carsten